import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.BufferedImage;

import java.util.function.Consumer;

public class FormShipConfig extends JFrame {
    public JPanel mainPanel;
    DrawingShip _ship;
    Consumer<DrawingShip> EventAddShip;
    private JPanel groupBoxConfig;
    private JLabel labelSpeed;
    private JSpinner numericUpDownSpeed;
    private JLabel labelWeight;
    private JSpinner numericUpDownWeight;
    private JCheckBox checkBoxContainers;
    private JCheckBox checkBoxCrane;
    private JPanel groupBoxColors;
    private JPanel PanelRed;
    private JPanel PanelBlue;
    private JPanel PanelWhite;
    private JPanel PanelYellow;
    private JPanel PanelBlack;
    private JPanel PanelGreen;
    private JPanel PanelPurple;
    private JPanel PanelCyan;
    private JLabel LabelSimple;
    private JLabel LabelModif;
    private JLabel LabelBaseColor;
    private JLabel LabelDopColor;
    private JPanel pictureBox;
    private JButton buttonAdd;
    private JButton buttonCancel;
    private JSpinner numericUpDownDecks;
    private JLabel labelDecks;
    private JLabel labelOvalDeck;
    private JLabel labelTrapezDeck;
    private JLabel labelSimpleDeck;
    private JLabel LabelDecksForm;
    private JPanel groupBoxPicture;
    Object ObjFDnD = null;
    Object TargetObjFDnD = null;
    public FormShipConfig()
    {
        super("Корабль");
        CreateWindow();

    }
    public void Draw(DrawingShip _ship)
    {
        pictureBox.removeAll();
        BufferedImage bmp = new BufferedImage(pictureBox.getWidth(), pictureBox.getHeight(),BufferedImage.TYPE_INT_RGB);
        Graphics gr = bmp.getGraphics();
        gr.setColor(new Color(238, 238, 238));
        gr.fillRect(0, 0, pictureBox.getWidth(), pictureBox.getHeight());
        if (_ship != null) {
            _ship.DrawTransport(gr);
            JLabel imageOfLoco = new JLabel();
            imageOfLoco.setPreferredSize(pictureBox.getSize());
            imageOfLoco.setMinimumSize(new Dimension(1, 1));
            imageOfLoco.setIcon(new ImageIcon(bmp));
            pictureBox.add(imageOfLoco,BorderLayout.CENTER);
        }
        revalidate();
    }
    public void AddEvent(Consumer<DrawingShip> ev){EventAddShip = ev;}
    public void CreateWindow() {
        setPreferredSize(new Dimension(720, 200));
        getContentPane().add(mainPanel);
        PanelBlack.setBorder(BorderFactory.createLineBorder(Color.BLACK, 2));
        PanelBlue.setBorder(BorderFactory.createLineBorder(Color.BLACK, 2));
        PanelRed.setBorder(BorderFactory.createLineBorder(Color.BLACK, 2));
        PanelYellow.setBorder(BorderFactory.createLineBorder(Color.BLACK, 2));
        PanelCyan.setBorder(BorderFactory.createLineBorder(Color.BLACK, 2));
        PanelPurple.setBorder(BorderFactory.createLineBorder(Color.BLACK, 2));
        PanelWhite.setBorder(BorderFactory.createLineBorder(Color.BLACK, 2));
        PanelGreen.setBorder(BorderFactory.createLineBorder(Color.BLACK, 2));
        LabelSimple.setText("Простой");
        LabelModif.setText("Модифицированный");
        LabelSimple.setBorder(BorderFactory.createLineBorder(Color.BLACK, 2));
        LabelModif.setBorder(BorderFactory.createLineBorder(Color.BLACK, 2));
        LabelBaseColor.setBorder(BorderFactory.createLineBorder(Color.BLACK, 2));
        LabelDopColor.setBorder(BorderFactory.createLineBorder(Color.BLACK, 2));
        labelSimpleDeck.setBorder(BorderFactory.createLineBorder(Color.BLACK, 2));
        labelTrapezDeck.setBorder(BorderFactory.createLineBorder(Color.BLACK, 2));
        labelOvalDeck.setBorder(BorderFactory.createLineBorder(Color.BLACK, 2));
        LabelDecksForm.setBorder(BorderFactory.createLineBorder(Color.BLACK, 2));
        numericUpDownSpeed.setModel(new SpinnerNumberModel(100, 100, 1000, 1));
        numericUpDownWeight.setModel(new SpinnerNumberModel(100, 100, 1000, 1));
        numericUpDownDecks.setModel(new SpinnerNumberModel(1, 1, 3, 1));
        MouseAdapter drag = new MouseAdapter() {
            @Override
            public void mousePressed(MouseEvent e) {
                setCursor(new Cursor(Cursor.HAND_CURSOR));
            }

            @Override
            public void mouseReleased(MouseEvent e) {
                setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
                Drop((JComponent) e.getSource());
            }
        };
        MouseAdapter defCursor = new MouseAdapter() {
            @Override
            public void mouseExited(MouseEvent e) {
                setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
            }
        };
        AdditDeckDropObject(labelOvalDeck);
        AdditDeckDropObject(labelSimpleDeck);
        AdditDeckDropObject(labelTrapezDeck);
        AdditDeckDropTarget(LabelDecksForm);
        pictureBox.addMouseListener(defCursor);
        LabelBaseColor.addMouseListener(defCursor);
        LabelDopColor.addMouseListener(defCursor);
        PanelRed.addMouseListener(drag);
        PanelBlack.addMouseListener(drag);
        PanelBlue.addMouseListener(drag);
        PanelYellow.addMouseListener(drag);
        PanelCyan.addMouseListener(drag);
        PanelWhite.addMouseListener(drag);
        PanelPurple.addMouseListener(drag);
        PanelGreen.addMouseListener(drag);
        LabelSimple.addMouseListener(drag);
        LabelModif.addMouseListener(drag);
        buttonAdd.addActionListener(e -> {
            EventAddShip.accept(_ship);
            dispose();
        });
        buttonCancel.addActionListener(e -> dispose());
    }
    void AdditDeckDropTarget(JComponent obj){
        obj.addMouseListener(new MouseAdapter() {
            @Override
            public void mouseEntered(MouseEvent e) {super.mouseEntered(e);
                Deck_DragEnter(obj);
            }
            @Override
            public void mouseExited(MouseEvent e) {super.mouseExited(e);
                DragExit();
            }
        });
    }
    void AdditDeckDropObject(JComponent obj){
        obj.addMouseListener(new MouseAdapter() {
            @Override
            public void mousePressed(MouseEvent e) {super.mousePressed(e);
                Deck_MouseDown(obj);
            }
            @Override
            public void mouseReleased(MouseEvent e) {super.mouseReleased(e);
                Deck_DragDrop();
            }
        });
    }
    public void Drop(JComponent dropditem)
    {
        if(dropditem==null)
        {
            return;
        }
        if(dropditem instanceof  JPanel panel)
        {
            if(_ship == null)
            {
                return;
            }
            if(LabelBaseColor.getMousePosition()!=null)
            {
                _ship.SetColor(panel.getBackground());
                Draw(_ship);
                revalidate();
            }
            if(LabelDopColor.getMousePosition()!=null && _ship instanceof DrawingContainerShip containerShip)
            {
                containerShip.SetDopColor(panel.getBackground());
                Draw(_ship);
                revalidate();
            }
        }
        if(dropditem instanceof  JLabel jLabel && pictureBox.getMousePosition()!=null)
        {
            int speed = (int)numericUpDownSpeed.getValue();
            int weight=(int)numericUpDownWeight.getValue();
            int NumDecks=(int)numericUpDownDecks.getValue();
            boolean crane= checkBoxCrane.isSelected();
            boolean containers= checkBoxContainers.isSelected();
            if(jLabel == LabelSimple)
            {
                _ship=new DrawingShip(speed,weight,Color.WHITE,NumDecks);
                Draw(_ship);
                revalidate();
            }
            else if(jLabel==LabelModif)
            {
                _ship=new DrawingContainerShip(speed,weight,Color.WHITE,NumDecks,Color.WHITE,crane,containers);
                Draw(_ship);
                revalidate();
            }
            if(_ship != null)
            {
                _ship.SetPosition(20,50,pictureBox.getWidth(),pictureBox.getHeight());
                Draw(_ship);
                revalidate();
            }
        }
    }
    void Deck_MouseDown(Object sender) {
        IAdditionalDrawingObject Deck;
        switch (((JLabel)sender).getText()){
            case "Овальные":
                Deck = new DrawingOvalDeck();
                break;
            case "Трапецевидные":
                Deck = new DrawingTrapezDeck();
                break;
            case "Прямоугольные":
                Deck = new DrawingDeck();
                break;
            default:
                return;
        }
        Deck.SetAddEnum((int)numericUpDownDecks.getValue());
        ObjFDnD  = Deck;
    }
    void Deck_DragEnter(Object sender){
        if(ObjFDnD!=null&& IAdditionalDrawingObject.class.isAssignableFrom(ObjFDnD.getClass())){
            setCursor(new Cursor(Cursor.HAND_CURSOR));
            TargetObjFDnD = sender;
        }
    }
    void Deck_DragDrop(){
        if(TargetObjFDnD==null) {return;}
        _ship.SetFormEnum((int)numericUpDownDecks.getValue(),(IAdditionalDrawingObject)ObjFDnD);
        DragExit();
        ObjFDnD = null;
    }
    void DragExit(){
        if(ObjFDnD!=null&&TargetObjFDnD!=null) {
            setCursor(Cursor.getDefaultCursor());
            Draw(_ship);
            TargetObjFDnD = null;
        }
    }
}
