import java.util.ArrayList;
import java.util.Iterator;
public class SetShipGeneric<T extends  Object> implements  Iterable<T>{
    private ArrayList<T> _places;
    private final int _maxCount;
    //private final Object[] _places;
    public int Count()
    {
        return  _places.size();
    }
    public SetShipGeneric(int count)
    {
        _maxCount=count;
        _places = new ArrayList<>();
    }
    public int Insert(T ship)
    {
        return Insert(ship, 0);
    }
    public int Insert(T ship, int position)
    {
        if (position < 0 || position > Count() || _maxCount == Count()) return -1;
        _places.add(position,ship);
        return position;
    }
    public T Remove(int position)
    {
        if (position >= Count() || position < 0)
        {
            return null;
        }
        T ship = (T) _places.get(position);
        _places.remove(ship);
        return ship;
    }
    public T Get(int position)
    {
        if (position >= Count() || position<0)
        {
            return null;
        }
        return _places.get(position);
    }
    public void Set(int position,T value)
    {
        if (position < _maxCount || position >= 0)
        {
            Insert(value,position);
        }
    }
    @Override
    public Iterator<T> iterator() {
        return _places.iterator();
    }
}

